import novemberizing from "./novemberizing.js";

export default class PopoverUI {
    static #popovers = new Set();

    static #off() {
        for(const popover of PopoverUI.#popovers) {
            const element = document.getElementById(popover);
            if(element.classList.contains("show")) {
                element.classList.replace("show", "hide");
            } else {
                element.classList.add("hide");
            }
        }
    }

    static on(event, id) {
        const target = document.getElementById(id);
        if(target.classList.contains('hide')) {
            target.classList.replace('hide', 'show');
            PopoverUI.#off();
            PopoverUI.#popovers.add(id);
        } else {
            target.classList.add('show');
            PopoverUI.#off();
            PopoverUI.#popovers.add(id);
        }
        const button = novemberizing.dom.parent(event.target, "button");
        const rect = button.getBoundingClientRect();
        target.addEventListener("click", e => {
            PopoverUI.toggle(event, id);
        }, { once: true });
        target.style.left = `${rect.left}px`;
        target.style.top = `${rect.top + window.scrollY - rect.height - 16}px`;
    }
    static toggle(event, id) {
        const target = document.getElementById(id);
        if(target.classList.contains('hide')) {
            target.classList.replace('hide', 'show');
            PopoverUI.#off();
            PopoverUI.#popovers.add(id);
            const button = novemberizing.dom.parent(event.target, "button");
            const rect = button.getBoundingClientRect();
            target.addEventListener("click", e => {
                PopoverUI.toggle(event, id);
            }, { once: true });
            target.style.left = `${rect.left}px`;
            target.style.top = `${rect.top + window.scrollY - rect.height - 16}px`;
        } else if(target.classList.contains('show')) {
            target.classList.replace('show', 'hide');
            PopoverUI.#popovers.delete(id);
        } else {
            target.classList.add('show');
            PopoverUI.#off();
            PopoverUI.#popovers.add(id);
            const button = novemberizing.dom.parent(event.target, "button");
            const rect = button.getBoundingClientRect();
            target.addEventListener("click", e => {
                PopoverUI.toggle(event, id);
            }, { once: true });
            target.style.left = `${rect.left}px`;
            target.style.top = `${rect.top + window.scrollY - rect.height - 16}px`;
        }
    }
}
